% try to do a fft on the temperature data
clear all, close all
load y_temp     % Temperature measurement sequence
y1 = y_temp.signals.values(1:end,2);

Ts = 0.5;          	% frequency
Fs = 1/Ts;          % Sample time
L = length(y1);     % Length of signal
y = detrend(y1);    % Remove linear trends


NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(y,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot single-sided amplitude spectrum.
semilogy(f,2*abs(Y(1:NFFT/2+1)))
title('Single-Sided Amplitude Spectrum of temperature measurement y_1(t)')
xlabel('Frequency (Hz)')
ylabel('|Y_1(f)|')

ax = axis;
axis([ax(1:2) 1e-4 1])