% Model identified by Manum
% Linearized around operation point 
% u* = [2 2 2]' and y* = [40.22 21.44]'
% y* changes with disturbances, i.e. room temp

A = [
    0.9884	-0.0107	0       0       0;
    -0.0163	0.9710	0       0       0;
    0       0      	0.4841  0.3383  -0.0210;
    0       0    	-0.5868 -0.2854 0.5170;
    0       0       0.2326  0.3695  0.8394
    ];

B = [
    0.0001  -0.0001 0;
    0.0001  -0.0002 0;
    0.0055  0       0.0017;
    0.0248  0       0.0075;
    -0.0083 0       -0.0025
    ];

C = [
    525.0571	-1.9821	0           0           0;
    0           0       773.8759	-153.2343	55.6699
    ];
    
D = zeros(2,3);


% State scaling
Z = diag([0.02 0.01 0.04 0.02 0.02]);
A = inv(Z)*A*Z; B = inv(Z)*B;
C = C*Z; D = D;

% Output scaling, can be introduced via Q
Dy = diag([1,8]);

% System struct
Ts = 0.5; % Sample time
udaq_sys = ss(A,B,C,D,Ts);
