%function IdentModel_Servo()
%clear all
close all
clc

%plant_num = 3.5;
%plant_den=[2 2 4 -2];
%f_time = 400;


%sim('pokusident')
%control(2)=control(1);
%save pokus time output1 output2 control
%save PB1 time elev_y azim_y control_e
save PB1a time elev_y azim_y control_a


% Identifikacia procesu modelom: ARX, ARMAX alebo IV4.
% vysledky sa ukldaju do
% IdentModelServo.mat 
% kde G_mat Gnum Gden t y1 y2 y3 u vzorka Tvz
%WorkingPoint time vel_fil1 vel_fil2 cal_vel control angle veloc 

CreateStruct.Resize='off';
CreateStruct.WindowStyle='modal';
CreateStruct.Interpreter='tex';
textMSG={'Identifikacia procesu modelom: ARX, ARMAX alebo IV4.','','\copyright MH  2007'};
handle=msgbox(textMSG,'IdentModel_Servo','none',CreateStruct);
waitfor(handle)

[fn,pn]=uigetfile('*.mat','Load');
if (all(pn == 0)|all(fn == 0)) return
else
  pathfilename = fullfile(pn,fn);
  name=evalin('caller',['load(''' pathfilename  ''')']);
end

time=name.time;   
%cal_vel=name.cal_vel;
elev=name.elev_y;

azim=name.azim_y;
%vel_fil2=name.vel_fil2;
%control=name.control_e;
control=name.control_a;
%angle=name.angle;

%vykreslenie dat
% figure
% %plot(time,cal_vel,'b',time,elev,'k',time,azim,'r',time,vel_fil2,'m')
% plot(time,elev,'b')
% title('Namerane data - vystup procesu  ');
% xlabel('t [s]'); ylabel('y [rad/s]')
% legend('elev-y')
% grid

% figure
% plot(time, control,'g')
% title('Namerane data - vstup do procesu')
% xlabel('t [s]'); ylabel('u [V]')
% grid

vzorka = 3000;
% % orezanie dat - experimentu pre identifikaciu + posunutie dat do 0
% if (control(1)==control(2))
%     n=length(control);
%     vzorka=1;
%     while control(vzorka)==control(1)
%         vzorka=vzorka+1;
%     end
% end
    
t = time;
Tvz = t(3)-t(2);

%t=time(1:(end-vzorka+2));
%y1=cal_vel(vzorka-1:end)-cal_vel(vzorka-1);         % cal_vel - prva vzorka: cal_vel(vzorka-1), ale skok na cal_vel(vzorka)
y1=elev(vzorka:end)-elev(vzorka);       % elev
y2=azim(vzorka:end)-azim(vzorka);       % azim
%y3=vel_fil2(vzorka-1:end)-vel_fil2(vzorka-1);       % vel_fil2
u=control(vzorka:end)-control(vzorka);
%u=control(vzorka-1:end)-control(vzorka-2);

t=t(1:(1210));
y2=y2(1:1210);
y1=y1(1:1210);
u=u(1:1210);

% vykreslenie orezanych dat
figure
plot(t,y1,'b',t, u,'g')
title('Data pre identifikaciu - vystup procesu - posunute do (0,0) ');
xlabel('t [s]'); ylabel('y [rad/s]')
legend('elev-y')
grid

figure
plot(t, u,'g')
title('Data pre identifikaciu - vstup do procesu - posunute do (0,0)')
xlabel('t [s]'); ylabel('u [V]')
grid
WorkingPoint=control(vzorka);

typModelu=questdlg('Zadajte typ modelu:','Typ modelu','ARX','ARMAX','IV4','IV4');
radModelu=questdlg('Zadajte rad modelu:','Rad modelu','1. rad','2. rad','3. rad','3. rad');
disp(' ');
    
 for iii=1:2,
%     if iii==1,
%         velicina='cal vel';
%         disp('*******************************************************');
%         disp('Prenosova funkcia pre cal_vel:   ');
%         y=y1; y1p=cal_vel(vzorka+1);
%     elseif iii==2,
%         velicina='vel fil1';
%         y=y2; y1p=azim(vzorka+1);
%         disp('*******************************************************');
%         disp('Prenosova funkcia pre azim:   ');
%     elseif iii==3,
%         velicina='vel fil2';
%         y=y3; y1p=vel_fil2(vzorka+1);
%         disp('*******************************************************');
%         disp('Prenosova funkcia pre vel_fil2:   ');
%     else 
    if iii==1
        velicina='elev';
        y=y1; y1p=elev(vzorka+1);
        disp('*******************************************************');
        disp('Prenosova funkcia pre elev:   ');
    elseif iii==2,
         velicina='azim';
         y=y2; y1p=azim(vzorka+1);
         disp('*******************************************************');
         disp('Prenosova funkcia pre azim:   ');
    end

    switch radModelu
        case '1. rad', r=1;rr='1';
        case '2. rad', r=2;rr='2';
        case '3. rad', r=3;rr='3';    
    end
%     if iii==1
%         r=4;
%         rr='4';
%     end
%     if iii==2
%         r=3;
%         rr='3';
%     end
    switch typModelu
        case 'ARX',   model=arx([y u],[r r 0]);
        case 'ARMAX', model=armax([y u],[r r 1 0]);
        case 'IV4',   model=iv4([y u],[r r 0]);
    end
    disp(char(strcat({'Typ modelu: '},{typModelu})))
    disp('-----------------');
    warning off
    [denD,numD]=polyform(model);
    [ad,bd,cd,dd]=tf2ss(numD,denD);
    [as,bs]=d2c(ad,bd,Tvz);
    [num,den]=ss2tf(as,bs,cd,dd,1);
    Gnum{iii}=num;
    Gden{iii}=den;
    
    %G_id = tf(num,den)
    
    warning on
    G_mat{iii}=tf(num,den);
    G_mat{iii}(1)%tf(num,den)
    ym=lsim(num,den,u,t);
    figure
%    plot(t,y+y1p,'b',t,ym+y1p,'r')
    plot(t,y,'b',t,ym,'r')
    title(char(strcat({'Porovnanie modelu '},{rr},'-ho radu s meranymi datami')))
    xlabel('t [s]'); ylabel('y [rad/s]')
    legend(char(strcat({'vystup procesu: '},{velicina})),char(strcat({'vystup modelu: '},{typModelu})))
    grid
    save prenos num den
end
%save IdentModelServo.mat G_mat Gnum Gden t y1 u vzorka Tvz time azim vel_fil2 cal_vel control elev typModelu
% disp(' Data su ulozene v IdentModelServo.mat')
% disp(' kde G_mat{1}(1) - prenosova funkcia pre cal_vel')
% disp('     G_mat{2}(1) - prenosova funkcia pre azim')
% disp('     G_mat{3}(1) - prenosova funkcia pre vel_fil2')
% disp('     G_mat{4}(1) - prenosova funkcia pre elev')
% disp('     typModelu - zvoleny typ modelu: ARX, ARMAX alebo IV4')
%frekv_plotovac;
