function [ probStruct ] = probStruct( varargin )
%CTRLSYS Generates a control struct on the form
%   probStruct = (Q,R,P,N) or
%   probStruct = (Q,R,P,N,W,V)
%   
%   where Q, R, and N are LQR weights,
%   W and V are disturbance and noise weights
    
if (nargin == 4)
    probStruct = struct();
    probStruct.Q = varargin{1};
    probStruct.R = varargin{2};
    probStruct.P = varargin{3};
    probStruct.N = varargin{4};
    probStruct.W = [];
    probStruct.V = [];
elseif (nargin == 6)
    probStruct = struct();
    probStruct.Q = varargin{1};
    probStruct.R = varargin{2};
    probStruct.P = varargin{3};
    probStruct.N = varargin{4};
    probStruct.W = varargin{5};
    probStruct.V = varargin{6};
else
    display('Please supply enough arguments!');
    display('Usage: probStruct(Q,R,P,N)');
    display('Usage: probStruct(Q,R,P,N,W,V)');
    return
end

end

