function [ sysStruct ] = sysStruct( varargin )
%GENSYS Generates a model struct on the form
%   sysStruct = (A,B,C,D,Ts)
%   D is set to 0 if omitted
%   Ts (sample time) is set to 1 if omitted
%   See Also SS

sysStruct = struct();

if (nargin < 3)
    display('Please supply enough arguments!');
    display('Usage: genSys(A,B,C,D,Ts)');
    return
elseif (nargin == 3)
    sysStruct.A = varargin{1};
    sysStruct.B = varargin{2};
    sysStruct.C = varargin{3};
    sysStruct.D = zeros(size(sysStruct.C,1), size(sysStruct.B,2)); % Default value
    sysStruct.Ts = 1; % Default value
elseif (nargin == 4)
    sysStruct.A = varargin{1};
    sysStruct.B = varargin{2};
    sysStruct.C = varargin{3};
    sysStruct.D = varargin{4};
    sysStruct.Ts = 1; % Default value
elseif (nargin == 5)
    sysStruct.A = varargin{1};
    sysStruct.B = varargin{2};
    sysStruct.C = varargin{3};
    sysStruct.D = varargin{4};
    sysStruct.Ts = varargin{5};
else
    display('Too many arguments!');
    display('Usage: genSys(A,B,C,D,Ts)');
    return
end

end

